from sManClass import cName
import wx, wx.xrc, os
def readSL(file):
    shaderFile = file.read()
    shader = cName()
    sVars = shaderFile.split("#!")
    sType = sVars[1].split()[2]
    sName = file.name.split("//")[-1].split(".")[0]
    shader.type = sType
    shader.name = sName
    return shader

def gatherSlData(name):
    shader = name.split("//")[-1].split(".sdl")[0]
    render = os.popen('sdrinfo "%s"'%(shader))
    vars = render.read()
    s = cName()
    for i,var in enumerate(vars.split("\n")):
        if var.find('"') >= 0:
            if i == 0:
                s.name = var.split('"')[1]
                s.type = var.split('"')[0]

            else:
                stype = var.split('"')
                try:
                        print var
                        if stype[3].find("float") >= 0:
                            if vars.split("\n")[i+1].find("Default") >= 0:
                                #print "\t", stype[1],vars.split("\n")[i+1].split()[-1]
                                exec("s.para%s = '%s'"%(stype[1],vars.split("\n")[i+1].split()[-1]))
                                
                        if stype[3].find("string") >= 0:
                            if vars.split("\n")[i+1].find("Default") >= 0:
                                #print "\t", stype[1],vars.split("\n")[i+1].split()[-1]
                                exec("s.para%s = '%s'"%(stype[1],vars.split("\n")[i+1].split()[-1]))
                        if stype[3].find("color") >= 0:
                            if vars.split("\n")[i+1].find("Default") >= 0:
                                print "\t", stype[1],vars.split("\n")[i+1].split("rgb")[-1][2:].split(":")[1]
                                exec("s.para%s = '%s'"%(stype[1],vars.split("\n")[i+1].split("rgb")[-1][2:].split(":")[1][1:]))
                        if stype[3].find("point") >= 0:
                            if vars.split("\n")[i+1].find("Default") >= 0:
                                #print "\t", stype[1],vars.split("\n")[i+1].split("shader")[-1][2:]
                                exec("s.para%s = '%s'"%(stype[1],vars.split("\n")[i+1].split("shader")[-1][2:]))
                        if stype[3].find("shader") >= 0:
                            if vars.split("\n")[i+1].find("Default") >= 0:
                                #print "\t", stype[1],vars.split("\n")[i+1].split("shader")[-1][2:]
                                exec("s.para%s = '%s'"%(stype[1],vars.split("\n")[i+1].split("shader")[-1][2:]))
                except IndexError: pass
    return s

class attributes(wx.Dialog):
    def __init__(self, parent):
        #dlg = wx.Dialog
        #dlg.__init__(self, parent)
        #self.Center()
        self.InitDialog()

        
    def InitDialog(self):
        evt = wx.EvtHandler
        
        
        self.res = wx.xrc.XmlResource("pixie.xrc")
        self.dlg  = self.res.LoadDialog(None, "attributeWindow")
        

        self.minsubdivision = wx.xrc.XRCCTRL(self.dlg, "minsubdivision")
        self.ID_OK = wx.xrc.XRCCTRL(self.dlg, "ID_OK")

        wx.EVT_BUTTON(self.dlg, wx.xrc.XRCID("ID_OK"), self.OnOk)
        wx.EVT_BUTTON(self.dlg, wx.xrc.XRCID("ID_CANCEL"), self.OnCancel)
    def getAttributes(self):
        ### Create a Dictionary and return it.
        attDict = {}
        for child in self.dlg.GetChildren():
            try:
                var = []
                if child.GetName() != "-1" and child.GetName() and str(child.GetName()).find("ID"):
                    var.append(child.GetName())
                    if var[0] == "minsubdivision":
                        var[0] = '"dice" "int minsubdivision"'
                        if child.GetValue() != "[2]":
                            var.append(child.GetValue())
                    if var[0] == "maxsubdivision":
                        var[0] = '"dice" "int maxsubdivision"'
                        if child.GetValue() != "[10]":
                            var.append(child.GetValue())
                    if var[0] == "numprobes":
                        var[0] = '"dice" "int numprobes[2]"'
                        if child.GetValue() != "[3 3]":
                            var.append(child.GetValue())
                    if var[0] == "minplits":
                        var[0] = '"dice" "int minplits"'
                        if child.GetValue() != "[2]":
                            var.append(child.GetValue())
                    if var[0] == "boundexpand":
                        var[0] = '"dice" "float boundexpand"'
                        if child.GetValue() != "[0.5]":
                            var.append(child.GetValue())
                    if var[0] == "binary":
                        var[0] = '"dice" "int binary"'
                        if child.GetValue() != "[0]":
                            var.append(child.GetValue())
                    if var[0] == "sphere":
                        var[0] = '"displacement" "float sphere"'
                        if child.GetValue() != "[0]":
                            var.append(child.GetValue())
                    if var[0] == "coordinatesystem":
                        att = child.GetString(child.GetSelection()) 
                        var[0] = '"displacement" "string coordinatesystem"'
                        if child.GetValue() != '"current"':
                            var.append(child.GetStringSelection())
                    if var[0] == "camera":
                        att = child.GetString(child.GetSelection()) 
                        var[0] = '"visibility" "int camera"'
                        if att != "[1]":
                            var.append(child.GetString(child.GetSelection()))
                    if var[0] == "trace":
                        att = child.GetString(child.GetSelection()) 
                        var[0] = '"visibility" "int trace"'
                        if att != "[0]":
                            var.append(child.GetString(child.GetSelection()))
                    if var[0] == "photon":
                        att = child.GetString(child.GetSelection()) 
                        var[0] = '"visibility" "int photon"'
                        if att != "[0]":
                            var.append(child.GetString(child.GetSelection()))
                    if var[0] == "transmission":
                        att = child.GetString(child.GetSelection()) 
                        var[0] = '"visibility" "string transmission"'
                        if att != '"transparent"':
                            var.append(child.GetString(child.GetSelection()))
                    if var[0] == "displacements":
                        att = child.GetString(child.GetSelection()) 
                        var[0] = '"trace" "int displacements"'
                        if att != "[0]":
                            var.append(child.GetString(child.GetSelection()))
                    if var[0] == "bias":
                        var[0] = '"trace" "float bias"'
                        if child.GetValue() != "[0.01]":
                            var.append(child.GetValue())
                    if var[0] == "maxdiffusedepth":
                        var[0] = '"trace" "int maxdiffusedepth"'
                        if child.GetValue() != "[1]":
                            var.append(child.GetValue())
                    if var[0] == "maxspeculardepth":
                        var[0] = '"trace" "int maxspeculardepth"'
                        if child.GetValue() != "[2]":
                            var.append(child.GetValue())
                    if var[0] == "handle":
                        var[0] = '"irradiance" "string handle"'
                        if child.GetValue() != '""':
                            var.append(child.GetValue())
                    if var[0] == "filemode":
                        var[0] = '"irradiance" "string filemode"'
                        if child.GetValue() != '""':
                            var.append(child.GetValue())
                    if var[0] == "maxerror":
                        var[0] = '"irradiance" "float maxerror"'
                        if child.GetValue() != "[0.5]":
                            var.append(child.GetValue())
                    if var[0] == "globalmap":
                        var[0] = '"photon" "string globalmap"'
                        if child.GetValue() != '""':
                            var.append(child.GetValue())
                    if var[0] == "causticmap":
                        var[0] = '"photon" "string causticmap"'
                        if child.GetValue() != '""':
                            var.append(child.GetValue())
                    if var[0] == "shadingmodel":
                        att = child.GetString(child.GetSelection()) 
                        var[0] = '"photon" "string shadingmodel"'
                        if att != '"matte"':
                            var.append(child.GetString(child.GetSelection()))
                    attDict[var[0]] = var[1]
            except: pass
        return attDict
    def OnOk(self,event):
        self.dlg.EndModal(wx.ID_OK)
    def OnCancel(self,event):
        self.dlg.EndModal(wx.ID_CANCEL)
        
class hider(wx.Dialog):
    def __init__(self, parent):
        self.InitDialog()     
    def InitDialog(self):
        evt = wx.EvtHandler    
        self.res = wx.xrc.XmlResource("pixie.xrc")
        self.dlg  = self.res.LoadDialog(None, "hiderWindow")   
        self.ID_OK = wx.xrc.XRCCTRL(self.dlg, "ID_OK")
        wx.EVT_BUTTON(self.dlg, wx.xrc.XRCID("ID_OK"), self.OnOk)
        wx.EVT_BUTTON(self.dlg, wx.xrc.XRCID("ID_CANCEL"), self.OnCancel)
    def getAttributes(self):
        ### Create a Dictionary and return it.
        attDict = {}
        for child in self.dlg.GetChildren():
            try:
                var = []
                if child.GetName() != "-1" and child.GetName() and str(child.GetName()).find("ID"):
                    var.append(child.GetName())
                    if var[0] == "Hider":
                        att = child.GetString(child.GetSelection()) 
                        if att != '"stochastic"':
                            var.append(child.GetString(child.GetSelection()))
                    attDict[var[0]] = var[1]
            except: pass
        return attDict
    def OnOk(self,event):
        self.dlg.EndModal(wx.ID_OK)
    def OnCancel(self,event):
        self.dlg.EndModal(wx.ID_CANCEL)
class options(wx.Dialog):
    def __init__(self, parent):
        self.InitDialog()     
    def InitDialog(self):
        evt = wx.EvtHandler    
        self.res = wx.xrc.XmlResource("pixie.xrc")
        self.dlg  = self.res.LoadDialog(None, "optionWindow")   
        self.ID_OK = wx.xrc.XRCCTRL(self.dlg, "ID_OK")
        wx.EVT_BUTTON(self.dlg, wx.xrc.XRCID("ID_OK"), self.OnOk)
        wx.EVT_BUTTON(self.dlg, wx.xrc.XRCID("ID_CANCEL"), self.OnCancel)
    def getAttributes(self):
        ### Create a Dictionary and return it.
        attDict = {}
        for child in self.dlg.GetChildren():
            try:
                var = []
                if child.GetName() != "-1" and child.GetName() and str(child.GetName()).find("ID"):
                    var.append(child.GetName())
                    if var[0] == "hider":
                        att = child.GetString(child.GetSelection()) 
                        var[0] = 'Hider'
                        if att != '"stochastic"':
                            var.append(child.GetString(child.GetSelection()))
                    attDict[var[0]] = var[1]
            except: pass
        return attDict
    def OnOk(self,event):
        self.dlg.EndModal(wx.ID_OK)
    def OnCancel(self,event):
        self.dlg.EndModal(wx.ID_CANCEL)
    
