import sManClass
from sManClass import cName
import os
def readSL(file):
    shaderFile = file.read()
    shader = cName()
    lines = str(shaderFile).split('\n')
    shader.name = str(file).split("'")[1].split(".")[0].split("//")[-1]
    for i,line in enumerate(lines):
        if line.find("code 6 24") >= 0:
            shader.type = None
        if line.find("code 6 29") >= 0:
            type = lines[i+1]
            if type == "0":
                shader.type = 'surface'
                return shader
            elif type == "1":
                shader.type = 'displacement'
                return shader
            elif type == "2":
                shader.type = 'atmosphere'
                return shader
            elif type == '3':
                shader.type = 'lightsource'
                return shader
            else:
                shader.type = None
                return shader          
    
def gatherSlData(name):
    shader = name
    render = os.popen('shaderinfo "%s"'%(shader))
    vars = render.read()
    s = cName()
    for i,var in enumerate(vars.split("\n")):
        if var.find('"') >= 0:
            if i == 1:
                s.name = var.split("//")[-1][:-1].split(".")[0]
                s.type = var.split('"')[0]
            else:
                stype = var.split('"')
                try:
                    paraHead = vars.split("\n")[i+1]
                    if paraHead.find("Default") >= 0:
                        if stype[3].find("float") >= 0:
                                #print "\t", stype[1],vars.split("\n")[i+1].split()[-1]
                                exec("s.para%s = '%s'"%(stype[1],vars.split("\n")[i+1].split()[-1]))
                        if stype[3].find("string") >= 0:    
                                #print "\t", stype[1],vars.split("\n")[i+1].split()[-1]
                                exec("s.para%s = '%s'"%(stype[1],vars.split("\n")[i+1].split(":")[1][1:]))
                        if stype[3].find("color") >= 0:
                                #print "\t", stype[1],vars.split("\n")[i+1].split("rgb")[-1][2:]
                                exec("s.para%s = '%s'"%(stype[1],vars.split("\n")[i+1].split("rgb")[-1][2:]))
                        if stype[3].find("shader") >= 0:
                                #print "\t", stype[1],vars.split("\n")[i+1].split("shader")[-1][2:]
                                exec("s.para%s = '%s'"%(stype[1],vars.split("\n")[i+1].split("shader")[-1][2:]))
                except IndexError: pass
    return s
